Attribute VB_Name = "basCstDr"
'=========================================================================
'   ݁`ppAPITv
'-------------------------------------------------------------------------
'   [RRg[] c[r[̃JX^h[
'-------------------------------------------------------------------------
'   [쐬]    2000N0712
'-------------------------------------------------------------------------
'   [NOTES]
'   VB6 Microsoft Common Controls 6.0 (SP4) gpTvłB
'=========================================================================
Option Explicit

'//==================== WIN32 API ========================================

Public Const WM_NOTIFY = &H4E
Public Const GWL_WNDPROC = -4
Public Const GWL_STYLE = (-16)

Public Type NMHDR
    hwndFrom    As Long
    idfrom      As Long
    code        As Long
End Type

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Public Type POINTAPI
    x           As Long
    y           As Long
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Const BDR_INNER = &HC
Public Const BDR_OUTER = &H3
Public Const BDR_RAISED = &H5
Public Const BDR_RAISEDINNER = &H4
Public Const BDR_RAISEDOUTER = &H1
Public Const BDR_SUNKEN = &HA
Public Const BDR_SUNKENINNER = &H8
Public Const BDR_SUNKENOUTER = &H2
Public Const BF_BOTTOM = &H8
Public Const BF_DIAGONAL = &H10
Public Const BF_FLAT = &H4000
Public Const BF_LEFT = &H1
Public Const BF_MIDDLE = &H800
Public Const BF_MONO = &H8000
Public Const BF_RIGHT = &H4
Public Const BF_SOFT = &H1000
Public Const BF_TOP = &H2
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Public Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Public Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Public Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Public Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Public Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
Public Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
Public Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
Public Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)
Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

Public Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long

'//==================== COMMON CONTROLS API ===================================

Public Const NM_FIRST = 0&
Public Const NM_CUSTOMDRAW = (NM_FIRST - 12)

Public Const TVS_SINGLEEXPAND = &H400
Public Const TVS_FULLROWSELECT = &H1000
Public Const TVS_TRACKSELECT = &H200

Public Const TVIS_EXPANDED = &H20

Public Const TV_FIRST = &H1100
Public Const TVM_SETBKCOLOR = (TV_FIRST + 29)
Public Const TVM_GETITEM = (TV_FIRST + 12)

Public Type TVITEM
    mask        As Long
    hItem       As Long
    state       As Long
    stateMask   As Long
    pszText     As Long
    cchTextMax  As Long
    iImage      As Long
    iSelectedImage  As Long
    cChildren   As Long
    lParam      As Long
End Type

Public Type NMTREEVIEW
    hdr         As NMHDR
    action      As Long
    itemOld     As TVITEM
    itemNew     As TVITEM
    ptDrag      As POINTAPI
End Type


'//==================== CUSTOM DRAW ==========================================

'// custom draw return flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDRF_DODEFAULT = &H0
Public Const CDRF_NEWFONT = &H2
Public Const CDRF_SKIPDEFAULT = &H4

Public Const CDRF_NOTIFYPOSTPAINT = &H10
Public Const CDRF_NOTIFYITEMDRAW = &H20
Public Const CDRF_NOTIFYSUBITEMDRAW = &H20         '// flags are the same, we can distinguish by context
Public Const CDRF_NOTIFYPOSTERASE = &H40

'// drawstage flags
'// values under =&H00010000 are reserved for global custom draw values.
'// above that are for specific controls
Public Const CDDS_PREPAINT = &H1
Public Const CDDS_POSTPAINT = &H2
Public Const CDDS_PREERASE = &H3
Public Const CDDS_POSTERASE = &H4
'// the =&H000010000 bit means it's individual item specific
Public Const CDDS_ITEM = &H10000
Public Const CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
Public Const CDDS_ITEMPOSTPAINT = (CDDS_ITEM Or CDDS_POSTPAINT)
Public Const CDDS_ITEMPREERASE = (CDDS_ITEM Or CDDS_PREERASE)
Public Const CDDS_ITEMPOSTERASE = (CDDS_ITEM Or CDDS_POSTERASE)
Public Const CDDS_SUBITEM = &H20000

'// itemState flags
Public Const CDIS_SELECTED = &H1
Public Const CDIS_GRAYED = &H2
Public Const CDIS_DISABLED = &H4
Public Const CDIS_CHECKED = &H8
Public Const CDIS_FOCUS = &H10
Public Const CDIS_DEFAULT = &H20
Public Const CDIS_HOT = &H40
Public Const CDIS_MARKED = &H80
Public Const CDIS_INDETERMINATE = &H100

Public Type NMCUSTOMDRAWINFO
    hdr         As NMHDR
    dwDrawStage As Long
    hdc         As Long
    rc          As RECT
    dwItemSpec  As Long
    uItemState  As Long
    lItemlParam As Long
End Type

Public Type NMTVCUSTOMDRAW
    nmcd        As NMCUSTOMDRAWINFO
    clrText     As Long
    clrTextBk   As Long
    iLevel      As Long
End Type

Private lpProcOrg   As Long

Public Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" (ByVal lpString1 As String, ByVal lpString2 As Long) As Long

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    Dim udtNMHdr    As NMHDR
    Dim udtNMTvw    As NMTREEVIEW
    Dim udtCdTvw    As NMTVCUSTOMDRAW
    Dim blnNoCall   As Boolean
    Dim lngForeColor    As Long
    Dim lngBackColor    As Long
    Dim udtRect     As RECT
    Dim udtTVItem   As TVITEM
    
    Select Case uMsg
        
    Case WM_NOTIFY
        
        CopyMemory udtNMHdr, ByVal lParam, LenB(udtNMHdr)
        
        If udtNMHdr.hwndFrom = frmCstDr.TreeView1.hwnd Then
            
            CopyMemory udtNMTvw, ByVal lParam, LenB(udtNMTvw)
            
            If udtNMTvw.hdr.code = NM_CUSTOMDRAW Then
                
                CopyMemory udtCdTvw, ByVal lParam, LenB(udtCdTvw)
                
                Select Case udtCdTvw.nmcd.dwDrawStage
                '-- Gloval Values
                Case CDDS_POSTERASE     ' After the erasing cycle is complete.
                Case CDDS_POSTPAINT     ' After the painting cycle is complete.
                Case CDDS_PREERASE      ' Before the erasing cycle begins.
                Case CDDS_PREPAINT      ' Before the painting cycle begins.
                    WindowProc = CDRF_NOTIFYITEMDRAW
                '-- Item-specific Values
                Case CDDS_ITEMPREPAINT
                    
                    If udtCdTvw.iLevel = 0 Then
                        lngForeColor = vbBlack
                        lngBackColor = RGB(192, 192, 192)
                    Else
                        If udtCdTvw.nmcd.uItemState And CDIS_SELECTED Then
                            lngForeColor = RGB(255, 192, 0)
                            lngBackColor = RGB(0, 54, 108)
                        Else
                            lngForeColor = vbWhite
                            lngBackColor = RGB(128, 128, 128)
                        End If
                    End If
                    udtCdTvw.clrTextBk = lngBackColor
                    udtCdTvw.clrText = lngForeColor
                    
                    CopyMemory ByVal lParam, udtCdTvw, LenB(udtCdTvw)
                                        
                    WindowProc = CDRF_NOTIFYPOSTPAINT
                                        
                Case CDDS_ITEMPOSTPAINT
                
                    If udtCdTvw.iLevel = 0 Then
                        udtTVItem.hItem = udtCdTvw.nmcd.dwItemSpec
                        udtTVItem.stateMask = TVIS_EXPANDED
                        TreeView_GetItem udtNMHdr.hwndFrom, udtTVItem
                        If udtTVItem.state And TVIS_EXPANDED Then
                            DrawEdge udtCdTvw.nmcd.hdc, udtCdTvw.nmcd.rc, BDR_SUNKEN, BF_RECT Or BF_SOFT
                        Else
                            DrawEdge udtCdTvw.nmcd.hdc, udtCdTvw.nmcd.rc, BDR_RAISED, BF_RECT Or BF_SOFT
                        End If
                        WindowProc = CDRF_NOTIFYPOSTPAINT
                    End If
                    
                                    
                End Select
                
            End If
        End If
    
    Case Else
    
    End Select
    If WindowProc = 0& Then
        WindowProc = CallWindowProc(lpProcOrg, hwnd, uMsg, wParam, lParam)
    End If
    
End Function

Public Function TreeView_SetBkColor(ByVal hwnd As Long, ByVal clr As Long) As Long
    TreeView_SetBkColor = SendMessage(hwnd, TVM_SETBKCOLOR, 0, ByVal clr)
End Function

Public Function TreeView_GetItem(ByVal hwnd As Long, pitem As TVITEM) As Long
    TreeView_GetItem = SendMessage(hwnd, TVM_GETITEM, 0, pitem)
End Function

Public Sub SubClass(ByVal hwnd As Long)
    lpProcOrg = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub UnSubClass(ByVal hwnd As Long)
    Dim lngRet  As Long
    lngRet = SetWindowLong(hwnd, GWL_WNDPROC, lpProcOrg)
End Sub

Public Function LOWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, dwValue, 2
    LOWORD = intVal
End Function

Public Function HIWORD(dwValue As Long) As Integer
    Dim intVal  As Integer
    CopyMemory intVal, ByVal VarPtr(dwValue) + 2, 2
    HIWORD = intVal
End Function

Public Function MAKELPARAM(ByVal wLow As Integer, ByVal wHigh As Integer) As Long
    MAKELPARAM = (CLng(wLow) * 2 ^ 16) + CLng(wHigh)
End Function
